unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, D3DX9, DirectDraw, StdCtrls ;

type
  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  hres: HRESULT;
  IDD: IDirectDraw;
  IDDS: IDirectDrawSurface;
  sIDDS: DDSurfaceDesc;

  imgsurface: IDirectDrawSurface;
  Simgsurface: DDSurfaceDesc;

  src:Trect;
  dst:Trect;
implementation

{$R *.dfm}

function DDCopyBitmap(pdds : IDirectDrawSurface; hbm : HBITMAP; x, y, dx, dy : Integer) : HRESULT;
var
 hdcImage : HDC;
 h_dc : HDC;
 bm : BITMAP;
 ddsd1 : TDDSurfaceDesc;
 hr : HRESULT;
begin
  if (hbm = 0) or (pdds = nil) then
    begin
      Result := E_FAIL;
      Exit;
    end;
  //
  // Make sure this surface is restored.
  //
  pdds._Restore;
  //
  // Select bitmap into a memoryDC so we can use it.
  //
  hdcImage := CreateCompatibleDC(0);
  if hdcImage = 0 then
    begin
      OutputDebugString('createcompatible dc failed');
    end;
  SelectObject(hdcImage, hbm);
  //
  // Get size of the bitmap
  //
  GetObject(hbm, sizeof(bm), @bm);
  if dx = 0 then                      // Use the passed size, unless zero
    begin
      dx := bm.bmWidth;
    end;
  if dy = 0 then
    begin
      dy := bm.bmHeight;
    end;
  //
  // Get size of surface.
  //
  ddsd1.dwSize := SizeOf(ddsd1);
  ddsd1.dwFlags := DDSD_HEIGHT or DDSD_WIDTH;
  pdds.GetSurfaceDesc(ddsd1);

  hr := pdds.GetDC(h_dc);
  if hr = DD_OK then
    begin
      StretchBlt(h_dc, 0, 0, ddsd1.dwWidth, ddsd1.dwHeight, hdcImage, x, y, dx, dy, SRCCOPY);
      pdds.ReleaseDC(h_dc);
    end;
  DeleteDC(hdcImage);
  Result := hr;
end;

procedure loadimg;
var
image:TBitmap;
begin
image:=Tbitmap.Create;
image.LoadFromFile('car2.bmp');

ZeroMemory(@Simgsurface,SizeOf(Simgsurface));
Simgsurface.dwSize:=SizeOf(Simgsurface);
Simgsurface.dwFlags:=DDSD_CAPS+DDSD_HEIGHT+DDSD_WIDTH;
Simgsurface.ddsCaps.dwCaps:=DDSCAPS_OFFSCREENPLAIN;
Simgsurface.dwHeight:= image.Height;
Simgsurface.dwWidth:= image.Width;

if IDD.CreateSurface(Simgsurface,imgsurface,nil)<>DD_OK then showmessage('Error surface not create!');

if  DDCopyBitmap(imgsurface,image.Handle,0,0,image.Width,image.Height)<> DD_OK then showmessage('    ');

image.Free
end;

procedure RestoreALL;
begin
if Succeeded(IDDS._Restore) then
begin
if Failed(imgsurface._Restore) then showmessage('  !');
 loadimg;
end else showmessage('  !');
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
IDD:=nil;
IDDS:=nil;
imgsurface:=nil;

hres:= DirectDrawCreate(nil,IDD,nil);
if hres<>DD_OK then showmessage('BAD!');


hres:= IDD.SetCooperativeLevel(form1.Handle, DDSCL_FULLSCREEN + DDSCL_EXCLUSIVE);
if hres<>DD_OK then showmessage('BAD!');

ZeroMemory(@sIDDS,SizeOf(sIDDS));
sIDDS.dwSize:=SizeOf(sIDDS);
sIDDS.dwFlags:=DDSD_CAPS;
sIDDS.ddsCaps.dwCaps:=DDSCAPS_PRIMARYSURFACE;

hres:= IDD.CreateSurface(sIDDS,IDDS,nil);
if hres<>DD_OK then showmessage('BAD!');

loadimg;
SetRect(src,0,0,42,79);
SetRect(dst,100,100,242,279);





end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
if IDD<>nil then
begin
imgsurface:=nil;
IDDS:=nil;
IDD:=nil;
end;


end;

procedure TForm1.FormPaint(Sender: TObject);
begin
if IDDS.Blt(@dst,imgsurface,@src,DDBLT_WAIT,nil)=DDERR_SURFACELOST then RestoreALL;
end;

end.
